Maximum subarray problem

From HandWiki
Short description: Problem in computer science
Visualization of how sub-arrays change based on start and end positions of a sample. Each possible contiguous sub-array is represented by a point on a colored line. That point's y-coordinate represents the sum of the sample. Its x-coordinate represents the end of the sample, and the leftmost point on that colored line represents the start of the sample. In this case, the array from which samples are taken is [2, 3, -1, -20, 5, 10].

In computer science, the maximum sum subarray problem, also known as the maximum segment sum problem, is the task of finding a contiguous subarray with the largest sum, within a given one-dimensional array A[1...n] of numbers. It can be solved in [math]\displaystyle{ O(n) }[/math] time and [math]\displaystyle{ O(1) }[/math] space.

Formally, the task is to find indices [math]\displaystyle{ i }[/math] and [math]\displaystyle{ j }[/math] with [math]\displaystyle{ 1 \leq i \leq j \leq n }[/math], such that the sum

[math]\displaystyle{ \sum_{x=i}^j A[x] }[/math]

is as large as possible. (Some formulations of the problem also allow the empty subarray to be considered; by convention, the sum of all values of the empty subarray is zero.) Each number in the input array A could be positive, negative, or zero.[1]

For example, for the array of values [−2, 1, −3, 4, −1, 2, 1, −5, 4], the contiguous subarray with the largest sum is [4, −1, 2, 1], with sum 6.

Some properties of this problem are:

  1. If the array contains all non-negative numbers, then the problem is trivial; a maximum subarray is the entire array.
  2. If the array contains all non-positive numbers, then a solution is any subarray of size 1 containing the maximal value of the array (or the empty subarray, if it is permitted).
  3. Several different sub-arrays may have the same maximum sum.

Although this problem can be solved using several different algorithmic techniques, including brute force,[2] divide and conquer,[3] dynamic programming,[4] and reduction to shortest paths, a simple single-pass algorithm known as Kadane's algorithm solves it efficiently.

History

The maximum subarray problem was proposed by Ulf Grenander in 1977 as a simplified model for maximum likelihood estimation of patterns in digitized images.[5]

Grenander was looking to find a rectangular subarray with maximum sum, in a two-dimensional array of real numbers. A brute-force algorithm for the two-dimensional problem runs in O(n6) time; because this was prohibitively slow, Grenander proposed the one-dimensional problem to gain insight into its structure. Grenander derived an algorithm that solves the one-dimensional problem in O(n2) time,[note 1] improving the brute force running time of O(n3). When Michael Shamos heard about the problem, he overnight devised an O(n log n) divide-and-conquer algorithm for it. Soon after, Shamos described the one-dimensional problem and its history at a Carnegie Mellon University seminar attended by Jay Kadane, who designed within a minute an O(n)-time algorithm,[5][6][7] which is as fast as possible.[note 2] In 1982, David Gries obtained the same O(n)-time algorithm by applying Dijkstra's "standard strategy";[8] in 1989, Richard Bird derived it by purely algebraic manipulation of the brute-force algorithm using the Bird–Meertens formalism.[9]

Grenander's two-dimensional generalization can be solved in O(n3) time either by using Kadane's algorithm as a subroutine, or through a divide-and-conquer approach. Slightly faster algorithms based on distance matrix multiplication have been proposed by (Tamaki Tokuyama) and by (Takaoka 2002). There is some evidence that no significantly faster algorithm exists; an algorithm that solves the two-dimensional maximum subarray problem in O(n3−ε) time, for any ε>0, would imply a similarly fast algorithm for the all-pairs shortest paths problem.[10]

Applications

Maximum subarray problems arise in many fields, such as genomic sequence analysis and computer vision.

Genomic sequence analysis employs maximum subarray algorithms to identify important biological segments of protein sequences.[citation needed] These problems include conserved segments, GC-rich regions, tandem repeats, low-complexity filter, DNA binding domains, and regions of high charge.[citation needed]

In computer vision, maximum-subarray algorithms are used on bitmap images to detect the brightest area in an image.

Kadane's algorithm

No empty subarrays admitted

Kadane's algorithm scans the given array [math]\displaystyle{ A[1\ldots n] }[/math] from left to right. In the [math]\displaystyle{ j }[/math]th step, it computes the subarray with the largest sum ending at [math]\displaystyle{ j }[/math]; this sum is maintained in variable current_sum.[note 3] Moreover, it computes the subarray with the largest sum anywhere in [math]\displaystyle{ A[1 \ldots j] }[/math], maintained in variable best_sum,[note 4] and easily obtained as the maximum of all values of current_sum seen so far, cf. line 7 of the algorithm.

As a loop invariant, in the [math]\displaystyle{ j }[/math]th step, the old value of current_sum holds the maximum over all [math]\displaystyle{ i \in \{ 1,\ldots, j-1 \} }[/math] of the sum [math]\displaystyle{ A[i]+\cdots+A[j-1] }[/math]. Therefore, current_sum[math]\displaystyle{ +A[j] }[/math][note 5] is the maximum over all [math]\displaystyle{ i \in \{ 1,\ldots, j-1 \} }[/math] of the sum [math]\displaystyle{ A[i]+\cdots+A[j] }[/math]. To extend the latter maximum to cover also the case [math]\displaystyle{ i=j }[/math], it is sufficient to consider also the singleton subarray [math]\displaystyle{ A[j \; \ldots \; j] }[/math]. This is done in line 6 by assigning [math]\displaystyle{ \max(A[j], }[/math]current_sum[math]\displaystyle{ +A[j]) }[/math] as the new value of current_sum, which after that holds the maximum over all [math]\displaystyle{ i \in \{ 1, \ldots, j \} }[/math] of the sum [math]\displaystyle{ A[i]+\cdots+A[j] }[/math].

Thus, the problem can be solved with the following code,[11] expressed in Python.

def max_subarray(numbers):
    """Find the largest sum of any contiguous subarray."""
    best_sum = - infinity
    current_sum = 0
    for x in numbers:
        current_sum = max(x, current_sum + x)
        best_sum = max(best_sum, current_sum)
    return best_sum

If the input contains no positive element, the returned value is that of the largest element (i.e., the value closest to 0), or negative infinity if the input was empty. For correctness, an exception should be raised when the input array is empty, since an empty array has no maximum nonempty subarray. If the array is nonempty, its first element could be used in place of negative infinity, if needed to avoid mixing numeric and non-numeric values.

The algorithm can be adapted to the case which allows empty subarrays or to keep track of the starting and ending indices of the maximum subarray.

This algorithm calculates the maximum subarray ending at each position from the maximum subarray ending at the previous position, so it can be viewed as a trivial case of dynamic programming.

Empty subarrays admitted

Kadane's original algorithm solves the problem variant when empty subarrays are admitted.[4][7] This variant will return 0 if the input contains no positive elements (including when the input is empty). It is obtained by two changes in code: in line 3, best_sum should be initialized to 0 to account for the empty subarray [math]\displaystyle{ A[0 \ldots -1] }[/math]

best_sum = 0;

and line 6 in the for loop current_sum should be updated as max(0, current_sum + x).[note 6]

current_sum = max(0, current_sum + x)

As a loop invariant, in the [math]\displaystyle{ j }[/math]th step, the old value of current_sum holds the maximum over all [math]\displaystyle{ i \in \{ 1,\ldots, j \} }[/math] of the sum [math]\displaystyle{ A[i]+\cdots+A[j-1] }[/math].[note 7] Therefore, current_sum[math]\displaystyle{ +A[j] }[/math] is the maximum over all [math]\displaystyle{ i \in \{ 1,\ldots, j \} }[/math] of the sum [math]\displaystyle{ A[i]+\cdots+A[j] }[/math]. To extend the latter maximum to cover also the case [math]\displaystyle{ i=j+1 }[/math], it is sufficient to consider also the empty subarray [math]\displaystyle{ A[j+1 \; \ldots \; j] }[/math]. This is done in line 6 by assigning [math]\displaystyle{ \max(0, }[/math]current_sum[math]\displaystyle{ +A[j]) }[/math] as the new value of current_sum, which after that holds the maximum over all [math]\displaystyle{ i \in \{ 1, \ldots, j+1 \} }[/math] of the sum [math]\displaystyle{ A[i]+\cdots+A[j] }[/math]. Machine-verified C / Frama-C code of both variants can be found here.

Computing the best subarray's position

The algorithm can be modified to keep track of the starting and ending indices of the maximum subarray as well.

Because of the way this algorithm uses optimal substructures (the maximum subarray ending at each position is calculated in a simple way from a related but smaller and overlapping subproblem: the maximum subarray ending at the previous position) this algorithm can be viewed as a simple/trivial example of dynamic programming.

Complexity

The runtime complexity of Kadane's algorithm is [math]\displaystyle{ O(n) }[/math] and its space complexity is [math]\displaystyle{ O(1) }[/math].[4][7]

Generalizations

Similar problems may be posed for higher-dimensional arrays, but their solutions are more complicated; see, e.g., (Takaoka 2002). (Brodal Jørgensen) showed how to find the k largest subarray sums in a one-dimensional array, in the optimal time bound [math]\displaystyle{ O(n + k) }[/math].

The Maximum sum k-disjoint subarrays can also be computed in the optimal time bound [math]\displaystyle{ O(n + k) }[/math] .[12]

See also

Notes

  1. By using a precomputed table of cumulative sums [math]\displaystyle{ S[k] = \sum_{x=1}^k A[x] }[/math] to compute the subarray sum [math]\displaystyle{ \sum_{x=i}^j A[x] = S[j] - S[i-1] }[/math] in constant time
  2. since every algorithm must at least scan the array once which already takes O(n) time
  3. named MaxEndingHere in (Bentley 1989), and c in (Gries 1982)
  4. named MaxSoFar in (Bentley 1989), and s in (Gries 1982)
  5. In the Python code below, [math]\displaystyle{ A[j] }[/math] is expressed as x, with the index [math]\displaystyle{ j }[/math] left implicit.
  6. While (Bentley 1989) does not mention this difference, using x instead of 0 in the above version without empty subarrays achieves maintaining its loop invariant current_sum[math]\displaystyle{ =\max_{i \in \{ 1, ..., j-1 \}} A[i]+...+A[j-1] }[/math] at the beginning of the [math]\displaystyle{ j }[/math]th step.
  7. This sum is [math]\displaystyle{ 0 }[/math] when [math]\displaystyle{ i=j }[/math], corresponding to the empty subarray [math]\displaystyle{ A[j\ldots j-1] }[/math].

References

  1. Bentley 1989, p. 69.
  2. Bentley 1989, p. 70.
  3. Bentley 1989, p. 73.
  4. 4.0 4.1 4.2 Bentley 1989, p. 74.
  5. 5.0 5.1 Bentley 1984, p. 868-869.
  6. Bentley 1989, p. 76-77.
  7. 7.0 7.1 7.2 Gries 1982, p. 211.
  8. Gries 1982, p. 209-211.
  9. Bird 1989, Sect.8, p.126.
  10. Backurs, Dikkala & Tzamos 2016.
  11. Bentley 1989, p. 78,171. Bentley, like Gries, first introduces the variant admitting empty subarrays, see below, and describes only the changes.
  12. Bengtsson & Chen 2007.
| url=http://comjnl.oxfordjournals.org/content/32/2/122.full.pdf
| first=Richard S.
| last= Bird 
| title=Algebraic Identities for Program Calculation 
| journal=The Computer Journal
| volume=32 
| number=2 
| pages=122–126 
| year=1989 
| doi=10.1093/comjnl/32.2.122 

External links